
package pjv.hodina10;

import java.awt.Rectangle;
import java.util.Observable;
import java.util.Observer;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tomas
 */
public class Controller implements Runnable, Observer{

    private Model model;   
    
    public Controller(Model model){
        this.model = model;               
        new Thread(this).start();
    }
    
    @Override
    public void run() {        
        while(true){
            try {
                Thread.sleep(20);
            } catch (InterruptedException ex) {
                Logger.getLogger(Controller.class.getName()).log(Level.SEVERE, null, ex);
                break;
            }
            synchronized(model){
                model.setxPosition((model.getxPosition()  + model.xVelocity) % model.getViewWidt());
                model.setyPosition((model.getyPosition()  + model.yVelocity) % model.getViewHeigh());
                model.notifyObservers();
            }            
        }       
        
    }

    @Override
    public void update(Observable o, Object arg) {
        if(arg != null && arg instanceof Rectangle){
            Rectangle rect = (Rectangle) arg;
            
            synchronized(model){
                model.setViewWidt(rect.width);
                model.setViewHeigh(rect.height);
                model.notifyObservers();
            }
            
        }
    }
    
}
